SHEBANG
# Copyright (C)2002..2022 @BABOLO http://www.babolo.ru/
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: addon-sftp.m4,v 1.5 2022/03/07 16:46:49 babolo Exp $

JNTROSTUP(sshd,-sftp,sshd,dnl
# jailup sshd-sftp dir
#     where dir relative to ${JAILUPDIR} and ${JAILRODIR}
# system sshd
#                                                   useddnl
)

jdir="${1}"
main_dir="${JAILUPDIR}/${jdir}"
conf_dir="${JAILRODIR}/${jdir}"
if  [ -n "${CONFSHIFT}" ]; then
    conf_dir="${conf_dir}/${CONFSHIFT}"
fi

${mkdir} "${main_dir}"
${up_mdir} "${main_dir}" ${MTREE}
${up_ldsh} << EOF | ${up_shlib} "${main_dir}/lib"
    /usr/bin/ssh
    ${PREFIX}/libexec/jailup/sshd/sftp-server
EOF

${up_libexe} "${main_dir}/libexec" << EOF
    ld-elf.so.1
    ${PREFIX}/libexec/jailup/sshd/sftp-server
EOF

cf="sshd_config"; if  [ -e "${conf_dir}/ssh/${cf}" ]; then cf="${cf}.sample"; fi
${cp} "${TEMPLATE}-sftp" "${conf_dir}/ssh/${cf}"

${mtree} -Ueqxp "${main_dir}" -f ${MTREE}
${mtree} -Ueqxp "${conf_dir}" << EOF
/set type=file uname=root gname=wheel mode=0644 flags=none
.			type=dir mode=0711
    group
    host.conf
    hosts
    hosts.allow
    localtime
    protocols
    resolv.conf
    ssh			type=dir mode=0700
/set type=file mode=0600
        sshd_config
        sshd_config.sample
    ..
..
EOF

      #####################################
      ####                             ####
      #### Begin of fstab mod          ####
      ####                             ####
${up_adc} "${STARTUPDIR}/devfs" <<- EOF
	# !!! Replace this for that from sshd !!!
	${jdir}	null	sshd-sftp
EOF
      ####                             ####
      #### End of fstab mod            ####
      ####                             ####
      #####################################
